(ns com.aurellem.title2
  (:use (com.aurellem gb-funs vbm)))

(defn first-difference [base alt summary root]
  (loop [branch-point root
         actions []]
    (let [base-branch (step branch-point base)
          base-val (summary base-branch)
          alt-branch (step branch-point alt)
          alt-val (summary alt-branch)]
      (if (not= base-val alt-val)
        [(conj actions alt) alt-branch]
        (recur base-branch (conj actions base))))))

(defn title []
  (let [[c-1 s-1] (first-difference [] [:a] AF (root))
        [c-2 s-2] (first-difference [] [:start] AF s-1)
        [c-3 s-3] (first-difference [] [:a] AF s-2)
        [c-4 s-4] (first-difference [] [:start] AF s-3)]
    [(concat c-1 c-2 c-3 c-3 c-4) s-4]))

(def menu-end (second (title)))

(defn scroll-text [[commands state]]
  (let [[c s] (first-difference [:b] [:a :b] AF state)]
    [(concat commands c) s]))

(defn oak []
  (-> [[] menu-end]
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text
      scroll-text))

(def oak-end (second (oak)))
  

;; looks like it might need a monad here if this pattern continues